# -*- coding: utf-8 -*-

import sys
import math
import types
import PyQt5.QtCore as core
import PyQt5.QtWidgets as widgets
import PyQt5.QtGui as gui
import PyQt5.uic as uic

points = []
br = gui.QBrush(core.Qt.black)
br.setStyle(core.Qt.SolidPattern)
scale = 1.0
angle = 0.0 # Bogenmaß
shiftX = 0.0
shiftY = 0.0

def handleEvent(self, event):
    global scale, angle, shiftX, shiftY
    if event.type() in [core.QEvent.TouchBegin, \
                        core.QEvent.TouchUpdate, \
                        core.QEvent.TouchEnd]:
        tp = event.touchPoints()
        points[:] = []
        if event.type() != core.QEvent.TouchEnd:
            for p in tp:
                points.append(p.pos())
        if len(tp) == 2 and tp[0].state() == core.Qt.TouchPointMoved \
                        and tp[1].state() == core.Qt.TouchPointMoved:
            pOneNew = tp[0].pos()
            pTwoNew = tp[1].pos()
            pOneOld = tp[0].lastPos()
            pTwoOld = tp[1].lastPos()
            
            diffNew = pOneNew - pTwoNew
            diffOld = pOneOld - pTwoOld
            scaleD = math.sqrt((diffNew.x()**2+diffNew.y()**2)/(diffOld.x()**2+diffOld.y()**2))
            scale *= scaleD
            angleD = math.atan2(diffNew.y(),diffNew.x())-math.atan2(diffOld.y(),diffOld.x())
            angle += angleD
            shiftX = pOneNew.x() - scaleD*(math.cos(angleD)*(pOneOld.x()-shiftX)-math.sin(angleD)*(pOneOld.y()-shiftY))
            shiftY = pOneNew.y() - scaleD*(math.sin(angleD)*(pOneOld.x()-shiftX)+math.cos(angleD)*(pOneOld.y()-shiftY))
        self.update()
    elif event.type() == core.QEvent.Paint:
        painter = gui.QPainter(self)
        painter.translate(shiftX, shiftY)
        painter.rotate(angle * 180.0 / math.pi)
        painter.scale(scale, scale)
        painter.drawImage(core.QPoint(0,0), img)
        painter.resetTransform()        
        painter.setBrush(br)
        for q in points:
            painter.drawEllipse(q, 20.0, 20.0)
    return True

app = widgets.QApplication(sys.argv)
w = uic.loadUi("touch.ui")
img = gui.QImage("test.png") # kann in PyQt5 erst nach Erzeugen der QApplication aufgerufen werden

app.setOverrideCursor(core.Qt.BlankCursor)
w.widget.setAttribute(core.Qt.WA_AcceptTouchEvents)
w.widget.event = types.MethodType(handleEvent, w.widget)

w.show()
sys.exit(app.exec_())